#pragma once

//#define	DELA( a )	{ if ( a!=NULL ){ delete[] a; a=NULL; }}
//#pragma warning( disable:4996 )

class CUrlList
{
public:
	enum	linktype{
		NONE = -1,
		URL = 0,
		RES,
	};

private:
	TCHAR	**m_url;
	linktype	*m_type;
	int		m_num;
	int		m_max;

	TCHAR	m_bbsname[100];
	TCHAR	m_datname[100];
	int		m_resnum;
public:

	CUrlList(int max)
	{
		m_url = new TCHAR*[max];
		m_type = new linktype[max];
		m_num = 0;
		m_max = max;
	}

	~CUrlList(void)
	{
		Release();
		DELA(m_url);
		DELA(m_type);
	}

	void	Release()
	{
		for( int i=0;i<m_num ;i++){
			DELA( m_url[i]);
		}
		m_num = 0;
	}

	void	SetText( TCHAR *txt )
	{
		PickUrl( txt );
		PickRes( txt );
	}

	TCHAR *GetUrl(int i){
		if ( i<m_num ){
			return m_url[i];
		}else{
			return NULL;
		}
	}

	linktype GetType(int i){
		if ( i<m_num ){
			return m_type[i];
		}else{
			return NONE;
		}
	}

	int	GetCount(){
		return m_num;
	}
private:
	TCHAR *NewString( TCHAR*txt )
	{
		TCHAR *ret = new TCHAR[ _tcslen(txt) +1 ];
		_tcscpy( ret , txt );
		return ret;
	}

	void	PickUrl( TCHAR *txt )
	{
		TCHAR	*p;
		TCHAR	*r;

		p = txt;
		while(1){
			r = _tcsstr( p , _T("tp:") );

			if ( r== NULL )	
				r= _tcsstr( p , _T("tps:") );

			if ( r== NULL )	
				break; 

			TCHAR	buff[2048];
			_stprintf( buff , _T("ht%s") , r );
			TCHAR *q =  _tcspbrk(buff , _T(" @\t\n\r<>" ) );
			if ( q!=NULL ){
				*q = _T('\0');
			}
			if ( m_num+1 < m_max ){
				m_url[m_num]  = NewString( buff );;
				m_type[m_num] = URL;
				m_num++;
			}
			p = _tcsstr( r, _T(":") );
		}
	}
	void	PickRes( TCHAR *txt )
	{
		TCHAR	*p;
		p = txt;
		while( (p= _tcsstr( p , _T(">>") ))!=NULL ){
			p+=2;
			int res = _ttoi( p );
			TCHAR	buff[20];
			_stprintf( buff , _T("%d") , res );
			if ( m_num+1 < m_max ){
				m_url[m_num]  = NewString( buff );;
				m_type[m_num] = RES;
				m_num++;
			}
		}
	}
public:

	bool	AnalyzeBBS( TCHAR *txt , TCHAR *name )
	{
		TCHAR *p =_tcsstr( txt ,name );
		if ( p==NULL ){
			return false;
		}

		p+= _tcslen( name );

		// /܂ŃRs[
		TCHAR *q = m_bbsname;
		while( *p!= _T('\0')  && *p != _T('/')  ){
			*q++ = *p++;
		}
		*q++ = _T('\0');

		if ( *p++ != _T('/') ){
			return false;
		}

		// ̘ARs[
		q = m_datname;
		while( *p!= _T('\0')  && _T('0')<=*p && *p<=_T('9')   ){
			*q++ = *p++;
		}
		*q++ = _T('\0');
		_tcscat( m_datname , _T(".dat") );

		m_resnum = _ttoi( p );

		return true;
	}


	// 2chNǂ
	bool CheckBBS( TCHAR *txt )
	{
		bool ret;
		ret = AnalyzeBBS( txt , _T(".2ch.net/test/read.cgi/") );
		if ( ret )	return ret;
		ret = AnalyzeBBS( txt , _T(".bbspink.com/test/read.cgi/") );
		if ( ret )	return ret;
		return false;
	}

	TCHAR	*GetBBSName(){
		return m_bbsname;
	}
	TCHAR	*GetDatname(){
		return m_datname;
	}
	int	GetResnum(){
		return m_resnum;
	}

};
