#pragma once

#define	MEMMAP_MAX	256

class	CMemMap {
private:
	void	*pMmap[MEMMAP_MAX];
	HANDLE	hMmap[MEMMAP_MAX];

public:
	CMemMap(){
		for( int i=0;i<MEMMAP_MAX;i++ ){
			pMmap[i]=NULL;
			hMmap[i]=NULL;
		}

	}
	virtual	~CMemMap(){
		for( int i=0;i<MEMMAP_MAX;i++ ){
			if ( hMmap[i]!=NULL ){
				OutputDebugString( _T("Memmap not released!\n"));
			}
		}
	}

	void *Alloc(int size)
	{
		int	i;
		// e[ű󂫂T
		for( i=0;i<MEMMAP_MAX;i++ ){
			// 󂫂
			if ( hMmap[i]==NULL ){
				// }bsOŃm
				void *buff = NULL;
				HANDLE hMap = CreateFileMapping((HANDLE)INVALID_HANDLE_VALUE,NULL,PAGE_READWRITE|SEC_COMMIT,0,size,NULL );
				if ( hMap != NULL ){
					buff = MapViewOfFile( hMap , FILE_MAP_WRITE , 0 , 0 , 0 );
					// e[uɓo^
					hMmap[i] = hMap;
					pMmap[i] = buff;
					return buff;
				}
			}
		}
		OutputDebugString( _T("Memmap can't allocate!\n") );
		return NULL;
	}

	void Free(void *mem)
	{
		int	i;
		// e[u|C^T
		for( i=0;i<MEMMAP_MAX;i++ ){
			// e[uɂ
			if ( pMmap[i]==mem ){
				UnmapViewOfFile( mem );
				CloseHandle(hMmap[i]);
				hMmap[i] = NULL;
				pMmap[i] = NULL;
				return ;
			}
		}
		OutputDebugString( _T("Memmap double release!\n") );
	}

};


