/**
 * @file debuglog.c
 *
 * @author Komatsudaira Yoshiki
 * @version $Id: debuglog.c 11 2006-11-10 14:53:16Z komatsu $
 */

#define	WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdarg.h>
//#include "libce/tinyio.h"

#ifndef _WIN32_WCE_EMULATION
#define	NKDbgPrintfW	1?(void)0:
#endif

/**
 * fobOOo
 *
 * fobOOo͂B
 * ɉso͂B
 *
 * @param fmt
 * @param ...
 * @return 
 */
int debuglogln0(const char *fmt, ...)
{
	char buf[512];
	WCHAR wb[512];
	va_list	va_ptr;
	int ret;

	va_start(va_ptr, fmt);
	ret = vsprintf(buf, fmt, va_ptr);
	va_end(va_ptr);
	MultiByteToWideChar( CP_ACP,						/* UINT		CodePage		*/
						 0,								/* DWORD	dwFlags			*/
						 buf,							/* LPCSTR	lpMultiByteStr	*/
						 -1,							/* int		cbMultiByte		*/	/* lpMultiByteStr ̃TCYoCgPʂŎw	*/
						 wb,							/* LPWSTR	lpWideCharStr	*/
						 sizeof(wb)/sizeof(wb[0]) );	/* int		cchWideChar		*/	/* Ch̒PʂŎw						*/
	NKDbgPrintfW(L"%s\n", wb);
	return ret;
}

/**
 * fobOOwb_o
 *
 * @param lbl
 * @return 
 */
int debugloghdr(const char *lbl)
{
	DWORD tick;
	char buf[512];
	int ret;

	tick = GetTickCount();
	ret = sprintf(buf, "[%010lu]%s: ", tick, lbl);
	NKDbgPrintfW(L"%S", buf);
	return ret;
}

/**
 * fobOOo
 *
 * fobOOo͂B
 *  -ɉs
 *
 * @param fmt
 * @param ...
 * @return 
 */
int debuglogbody(const char *fmt, ...)
{
	char buf[512];
	WCHAR wb[512];
	va_list	va_ptr;
	int ret;

	va_start(va_ptr, fmt);
	ret = vsprintf(buf, fmt, va_ptr);
	va_end(va_ptr);
	MultiByteToWideChar( CP_ACP,						/* UINT		CodePage		*/
						 0,								/* DWORD	dwFlags			*/
						 buf,							/* LPCSTR	lpMultiByteStr	*/
						 -1,							/* int		cbMultiByte		*/	/* lpMultiByteStr ̃TCYoCgPʂŎw	*/
						 wb,							/* LPWSTR	lpWideCharStr	*/
						 sizeof(wb)/sizeof(wb[0]) );	/* int		cchWideChar		*/	/* Ch̒PʂŎw						*/
	NKDbgPrintfW(L"%s\n", wb);
	return ret;
}

/**
 * fobOOo
 *
 * fobOOo͂B
 *  -x(֐z)
 *  -tick
 *  -ɉs
 *
 * @param lbl
 * @param ...
 * @return 
 */
int debuglogln(const char *lbl, const char *fmt, ...)
{
	DWORD tick;
	char buf[512];
	WCHAR wb[512];
	va_list	va_ptr;
	int ret;

	tick = GetTickCount();
	ret = sprintf(buf, "[%010lu]%s: ", (unsigned long)tick, lbl);

	va_start(va_ptr, fmt);
	ret += vsprintf(buf+ret, fmt, va_ptr);
	va_end(va_ptr);
	MultiByteToWideChar( CP_ACP,						/* UINT		CodePage		*/
						 0,								/* DWORD	dwFlags			*/
						 buf,							/* LPCSTR	lpMultiByteStr	*/
						 -1,							/* int		cbMultiByte		*/	/* lpMultiByteStr ̃TCYoCgPʂŎw	*/
						 wb,							/* LPWSTR	lpWideCharStr	*/
						 sizeof(wb)/sizeof(wb[0]) );	/* int		cchWideChar		*/	/* Ch̒PʂŎw						*/
	NKDbgPrintfW(L"%s\n", wb);
	return ret;
}
