/**
 * @file debuglog.h
 *
 * @author Komatsudaira Yoshiki
 * @version $Id: debuglog.h 5 2006-11-10 00:34:01Z komatsu $
 */

#ifndef DEBUGLOG_H
#define	DEBUGLOG_H


#ifdef __cplusplus
extern "C" {
#endif

int debuglogln0(const char *fmt, ...);
int debuglogln(const char *lbl, const char *fmt, ...);

int debugloghdr(const char *lbl);
int debuglogbody(const char *fmt, ...);

#define	DBGLBL(lbl)		static char const *const __func = lbl;

#define	TO_STRING(x)		#x
#define	_THRU(x)			TO_STRING(x)
//#define	DBGLOGLN(x)			debuglogln(__func, TO_STRING(x))
//#define	DBGLOGLN(x)			debuglogln0(__func)
#define	DBGLOGLN(x)		debugloghdr(__func), debuglogbody x;


#ifdef __cplusplus
}
#endif


#endif
